// источнк
// https://3d-diy.ru/wiki/arduino-mechanics/stepper-motor-28BYJ-48/#Connection
/*
Описание команд библиотеки AccelStepper.h

AccelStepper mystepper(DRIVER, step, direction);// Шаговый двигатель, управляемый платой
AccelStepper mystepper(FULL2WIRE, pinA, pinB);// Шаговый двигатель, управляемый Н-мостом
AccelStepper mystepper(FULL4WIRE, pinA1, pinA2, pinB1, pinB2);// Униполярный двигатель, например, 

mystepper.setMaxSpeed(stepsPerSecond);// Установка скорости оборотов в минуту
mystepper.setSpeed(stepsPerSecond);// Установка скорости в шагах за секунду
mystepper.setAcceleration(stepsPerSecondSquared);// Установка ускорения

mystepper.currentPosition(); // Возвращает текущее положение в шагах
mystepper.setCurrentPosition (long position); Обнуляет текущую позицию до нуля
mystepper.targetPosition(); // Конечное положение в шагах
mystepper.distanceToGo(); // Вернуть расстояние до указанного положения
mystepper.moveTo(long absolute); // Переместиться в абсолютно указанное положение
mystepper.move(long relative); // Переместиться в относительно указанное положение

mystepper.run(); // Начать движение с ускорением, функцию следует вызывать повторно
mystepper.runToPosition(); // Начать движение до указанной точки
mystepper.runToNewPosition(); // Начать движение с ускорением до заданной позиции
mystepper.stop(); // Максимально быстрая остановка (без замедления)
mystepper.runSpeed(); // Начать движение с заданной скоростью без плавного ускорения
mystepper.runSpeedToPosition(); // Начать движение без плавного ускорения, до позиции

mystepper.disableOutputs(); // Деактивирует зарезервированные пины и устанавивает их в режим LOW. Снимает напряжение с обмоток двигателя, экономя энергию
mystepper.enableOutputs(); // Активирует зарезервированные пины и устанавивает их в режим OUTPUT. Вызывается автоматически при запуске двигателя

*/
// подключение библиотеки
#include <AccelStepper.h>
// создаем экземпляр AccelStepper
#define IN1 8
#define IN2 9
#define IN3 10
#define IN4 11
AccelStepper s28BYJ48(8, IN1, IN3, IN2, IN4);

// клавиши выбора режима
int pinButtons []={5,6,7};
int lastButtons []={0,0,0};
int currentBut[]={0,0,0};
//
boolean go=false;

void setup(){
  Serial.begin(9600);
  s28BYJ48.setMaxSpeed(1000);
  s28BYJ48.setAcceleration(100);
  s28BYJ48.setSpeed(-500);//- 500 norm
  Serial.begin(9600);
}

void loop() {
  // проверка нажатия кнопок выбора программ
  for(int i=0;i<3;i++) {
     currentBut[i] = deb(lastButtons[i],pinButtons[i]);
     // если нажатие...
     if (lastButtons[i] == 0 && currentBut[i] == 1) {
        switch(i) {
           case 0:   // против часовой
                 s28BYJ48.setSpeed(500);//500 norm
                 go=true;
                 Serial.println("CW");
              break;
           case 1:   // стоп
                 s28BYJ48.stop();
                 go=false;
                 Serial.println("stop");
              break;
           case 2:   // по часовой
                 s28BYJ48.setSpeed(-500);// -500 norm
                 go=true;
                 Serial.println("CCW");
              break;
           default:
              break;
        }
     }
     lastButtons[i] = currentBut[i];
  }
  if(go==true)
     s28BYJ48.runSpeed();

}

// устранение дребезга
int deb (int l,int pin){
  int c = digitalRead(pin);
  if (l != c) { // если изменение
    delay(5);
    c = digitalRead(pin);
    }
        return c;
  }
