#define PIN_TRIG 12
#define PIN_ECHO 11
#include <Servo.h>                                      // подключаем библиотеку для работы с сервоприводом
Servo Barrier;                                          // объявляем переменную  типа Servo
const uint8_t  pinLamp[3]  = {9,6,3};
bool           flgLamp[3]  = {0,0,0};  
long           duration, cm =0;
boolean        FlagServoIsOpened = true; 

// ******************** Функция светофора ***********************
              void fTrafficLights(){
               
                     if (FlagServoIsOpened){                // FlagServoIsOpened == true
                      digitalWrite(pinLamp[1],HIGH);
                      digitalWrite(pinLamp[2],LOW);
                      } else {
                      digitalWrite(pinLamp[1],LOW);
                      digitalWrite(pinLamp[2],HIGH);         
                      }
                 }
              
              void fTrafficLights1(){
                if (cm>30 && cm<60){                                 //
                  digitalWrite(pinLamp[0],HIGH);
                  delay (100);
                  digitalWrite(pinLamp[0],LOW);
                  delay (100);
                    } else {digitalWrite(pinLamp[0],LOW);
                    }
              }
// --------------------------------------------------------------

void setup() {
  Serial.begin (9600);// Инициализируем взаимодействие по последовательному порту
  
  //Определяем вводы и выводы
  pinMode(PIN_TRIG, OUTPUT);
  pinMode(PIN_ECHO, INPUT);
  //
          for(uint8_t i=0; i<sizeof(pinLamp); i++){                       
            pinMode      (pinLamp[i], OUTPUT);             // инициируем пины светофора              
            //digitalWrite (pinLamp[i], flgLamp[i]);                       
          }
  //
} // setup

void loop() {
  // Сначала генерируем короткий импульс длительностью 2-5 микросекунд.
  digitalWrite(PIN_TRIG, LOW);
  delayMicroseconds(5);
  digitalWrite(PIN_TRIG, HIGH);

  // Выставив высокий уровень сигнала, ждем около 10 микросекунд. В этот момент датчик будет посылать сигналы с частотой 40 КГц.
  delayMicroseconds(10);
  digitalWrite(PIN_TRIG, LOW);

  //  Время задержки акустического сигнала на эхолокаторе.
  duration = pulseIn(PIN_ECHO, HIGH);

  // Теперь осталось преобразовать время в расстояние
  cm = (duration / 2) / 29.1;

  Serial.print("Расстояние до объекта: ");
  Serial.print(cm);
  Serial.println(" см.");

  // Задержка между измерениями для корректной работы скеча
  delay(250);
  fTrafficLights1(); // задействуем светофор
  if(cm < 30 && FlagServoIsOpened){
    //digitalWrite(pinLamp[1],HIGH);
    fTrafficLights(); // задействуем светофор
    Barrier.attach(10); // привязываем сервопривод выходу, т.е. приводим в готовность
    Barrier.write(0);                                // ставим угол поворота под 0
    
    FlagServoIsOpened= false;
    delay(500);                                       // 2000 мс - слишком долго, 100 - не достаточно
    Barrier.detach();                                //  Отключить сервопривод
        } // if
        else if (cm > 30 && !FlagServoIsOpened) {
                                                   //
    //digitalWrite(pinLamp[1],LOW);
    fTrafficLights(); // задействуем светофор
    Barrier.attach(10); // привязываем сервопривод выходу, т.е. приводим в готовность
    Barrier.write(90);                              // ставим угол поворота под 90
    
    FlagServoIsOpened= true;
    delay(500);                                      // 2000 мс - слишком долго, 100 - не достаточно
    Barrier.detach();                                //  Отключить сервопривод
        } // if else 
}
