#define PIN_TRIG 12
#define PIN_ECHO 11
#include <Servo.h>                            // подключаем библиотеку для работы с сервоприводом
Servo Barrier;         // Pin10                        // объявляем переменную servo типа "servo1"
const uint8_t  pinLamp[3]  = {9,6,3};
bool           flgLamp[3]  = {0,0,0};  
long           duration, cm;
boolean        FlagServoIsOpened = true; 

void setup() {
  Serial.begin (9600);// Инициализируем взаимодействие по последовательному порту
  Barrier.attach(10); // привязываем сервопривод к аналоговому выходу 11
  //Определяем вводы и выводы
  pinMode(PIN_TRIG, OUTPUT);
  pinMode(PIN_ECHO, INPUT);
      for(uint8_t i=0; i<sizeof(pinLamp); i++){                       
        pinMode      (pinLamp[i], OUTPUT);                           
        digitalWrite (pinLamp[i], flgLamp[i]);                       
}
}

void loop() {

  // Сначала генерируем короткий импульс длительностью 2-5 микросекунд.

  digitalWrite(PIN_TRIG, LOW);
  delayMicroseconds(5);
  digitalWrite(PIN_TRIG, HIGH);

  // Выставив высокий уровень сигнала, ждем около 10 микросекунд. В этот момент датчик будет посылать сигналы с частотой 40 КГц.
  delayMicroseconds(10);
  digitalWrite(PIN_TRIG, LOW);

  //  Время задержки акустического сигнала на эхолокаторе.
  duration = pulseIn(PIN_ECHO, HIGH);

  // Теперь осталось преобразовать время в расстояние
  cm = (duration / 2) / 29.1;

  Serial.print("Расстояние до объекта: ");
  Serial.print(cm);
  Serial.println(" см.");

  // Задержка между измерениями для корректной работы скеча
  delay(250);

  if(cm < 20 && FlagServoIsOpened){
    digitalWrite(pinLamp[1],HIGH);
    Barrier.write(0);                                  // ставим угол поворота под 0
    FlagServoIsOpened= false;
    delay(2000);                                        // ждем 2 секунды
                                                        //     
        } 
        else if (cm > 20 && !FlagServoIsOpened) {
                                                        //
    digitalWrite(pinLamp[1],LOW);
    Barrier.write(90);                                  // ставим угол поворота под 90
    FlagServoIsOpened= true;
    delay(2000);                                       // ждем 2 секунды
        } // if else 
}
