const uint8_t  pinSensor   = A0;                                     // Номер вывода к которому подключён датчик звука (можно изменить на любой другой аналоговый вывод).
const uint16_t varVolume   = 400;                                    // Минимальный уровень громкости (значение от 0 до 1023). Чем ниже значение, тем чувствительнее устройство.
const uint16_t varDuration = 2000;                                   // Время которое отводится на хлопки (в миллисекундах), за это время Вы должны успеть совершить максимальное количество хлопков.
const uint8_t  pinLamp[3]  = {9,6,3};                                // Номера выводов к которым подключены лампы (первая лампа подключена к 9 выводу, вторая к 6 и третья к 3). Можно указывать любые выводы.
const uint8_t  varLamp[3]  = {2,3,4};                                // Количество хлопков для реакции ламп (первая лампа реагирует на 2 хлопка, вторая на 3 и третья на 4). Можно указывать любое количество хлопков.
bool           flgLamp[3]  = {0,0,0};                                // Флаги состояния ламп (1-вкл / 0-выкл). Установленные в данной строке значения применяются к лампам при старте.
uint8_t        varSum;                                               // Переменная для подсчёта количества хлопков за время varDuration.
uint32_t       varTimeOut;
int CurrentPinSensor = 0;
                                                                     // Переменная для хранения времени завершения сессии хлопков.


                                                                     //
void setup(){ 
  Serial.begin(9600);                                                //
    for(uint8_t i=0; i<sizeof(pinLamp); i++){                        // Проходим по всем выводам к которым подключены лампы ...
        pinMode      (pinLamp[i], OUTPUT);                           // Конфигурируем вывод очередной лампы как выход (OUTPUT).
        digitalWrite (pinLamp[i], flgLamp[i]);                       // Устанавливаем на этом выводе состояние лампы flgLamp.
}   }                                                                //
                                                                     //
void loop(){ 
  CurrentPinSensor = analogRead(pinSensor);
  Serial.println(CurrentPinSensor);
//  delay(100);                                                                   //
//  Если зафиксирован хлопок:                                        //
    if(analogRead(pinSensor)>varVolume){                             // Если зафиксирован уровень звука выше значения varVolume, то ...
//      Считаем количество хлопков за время varDuration:             //
        varSum = 0;                                                  // Сбрасываем счетчик количества хлопков.
        varTimeOut = millis() + varDuration;                         // Определяем время завершения текущей сессии хлопков (текущее время + varDuration).
        while(varTimeOut > millis()){                                // Уходим в цикл пока не наступит время завершения текущей сессии хлопков ...
            if(analogRead(pinSensor) > varVolume){                   // Если зафиксирован уровень звука выше значения varVolume, то ...
                while(analogRead(pinSensor) > varVolume){delay(50);} // Уходим в цикл ожидания завершения текущего хлопка. Задержка delay(50) подавляет дребезг начала хлопка.
                varSum++;                                delay(50);  // Учитываем этот хлопок увеличивая значение varSum.  Задержка delay(50) подавляет дребезг окончания хлопка.
        }   }                                                        //
//      Время varDuration вышло, количество хлопков подсчитано и хранится в varSum, выполняем действия:
        for(uint8_t i=0; i<sizeof(varLamp); i++){                    // Проходим по всем лампам ...
            if(varSum == varLamp[i]){                                // Если количество хлопков varSum совпало со значением varLamp одной из ламп, то ...
                flgLamp[i] =! flgLamp[i];                            // Меняем состояние флага flgLamp для этой лампы.
                digitalWrite(pinLamp[i],flgLamp[i]);                 // Устанавливаем логический уровень на выводе pinLamp в соответствии со значением флага flgLamp.
    }   }   }                                                        //
//  В этом месте можно написать свой код ...                         // Этот который будет выполняться в то время, пока не фиксируются хлопки.
}                                                                    //
